TEMPLATE = app
DEPENDPATH += include
INCLUDEPATH += include 

QT   += opengl
LIBS += -lcxcore -lcv 

win32 {
	INCLUDEPATH += "C:\Program Files (x86)\OpenCV\cxcore\include" "C:\Program Files (x86)\OpenCV\cv\include" "C:\Program Files (x86)\boost\boost_1_36_0"
	LIBPATH += dependencies
	DEFINES += WIN32 _SCL_SECURE_NO_WARNINGS
	CONFIG += console
}

unix {
	LIBS += -lboost_program_options -llapack -lblas -lcblas
	INCLUDEPATH += /usr/include/opencv
}

CONFIG += debug
OBJECTS_DIR  = obj
MOC_DIR  = obj
QMAKE_CXXFLAGS += -O3 -march=native -msse2 -ftree-vectorize -fopenmp

# Input
HEADERS += include/hair/common.h \
           include/hair/timer.h \ 
           include/hair/parameters.h \ 
           include/hair/imageio.h \ 
           include/hair/filter.h \ 
           include/hair/obb.h \
           include/hair/kdtree.h \
		   include/hair/datamodel.h \
		   include/hair/wthread.h \
           include/hair/glwidget.h \
           include/hair/glviewer.h

SOURCES += src/common.cpp \
		   src/timer.cpp \
           src/parameters.cpp \
           src/imageio.cpp \
           src/filter.cpp \
		   src/obb.cpp \
		   src/kdtree.cpp \
		   src/datamodel.cpp \
		   src/trackball.c \
		   src/wthread.cpp \
		   src/glwidget.cpp \
		   src/glviewer.cpp 
