#if !defined(__COMMON_H)
#define __COMMON_H

#define VERSION_STRING "Fiber-Growing Tool v0.4"
#define MAX_ACTIVESET_SIZE 24
#define Epsilon 1e-5

#ifdef WIN32
	#define _CRT_SECURE_NO_WARNINGS 1
	#define NOMINMAX
	#define _WIN32_WINNT 0x0501
	#include <windows.h>

	#define _USE_MATH_DEFINES 1
	#include <math.h>
	#define PATH_MAX 1024
	#define snprintf _snprintf
	#define strdup _strdup

	typedef unsigned char uint8_t;
	typedef unsigned long long uint64_t;
#endif

typedef float Float;

#include <iostream>
#include <cmath>
#include <vector>
#include <sstream>
#include <functional>
#include <limits>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <cv.h>
#include <limits>
#include <limits.h>
#include <sstream>
#include <stdexcept>
#include <hair/vector.h>
#include <hair/aabb.h>

/// Convert radians to degrees
inline Float radToDeg(Float rad) {
	return 180.0f*rad/(Float)M_PI;
}

/// Convert degrees to radians
inline Float degToRad(Float deg) {
	return deg*(Float)M_PI/180.0f;
}
using namespace std;

extern std::string formatString(const char *pFmt, ...);
extern std::string timeToString(Float time);

/// Ordering for using pixels as keys in a set data structure
struct pixel_ordering : public 
	std::binary_function<Point3s, Point3s, bool> {
public:
	bool operator()(const Point3s &i, const Point3s &j) const {
		if (i.z < j.z)
			return false;
		else if (i.z > j.z)
			return true;

		if (i.y < j.y)
			return false;
		else if (i.y > j.y)
			return true;

		if (i.x < j.x)
			return false;
		else if (i.x > j.x)
			return true;

		return false;
	}
};

typedef std::set<Point3s, pixel_ordering> PixelSet;

#endif /* __COMMON_H */
