#if !defined(__FILTER_H)
#define __FILTER_H

#include <hair/parameters.h>
#include <hair/imageio.h>
#include <hair/kdtree.h>

/* Filter an image using a Gabor filter bank & apply hysteresis thresholding.
   Returns a vector of observations in the form of oriented pixels */
extern void findHairs(IplImage *input, IplImage *debug, int depth,
	std::vector<KDTree::Observation> &result,
	const Parameters &parameters);

/* Run the whole filter stage as configured by the 'parameters' data structure */
extern void runFilterStage(const Parameters &parameters);

#endif /* __FILTER_H */
