#ifndef __GLVIEWER_H
#define __GLVIEWER_H

#include <hair/datamodel.h>
#include <hair/timer.h>
#include <hair/glwidget.h>
#include <QtGui>
#include <QGLWidget>

class GLWidget;

class GLViewer : public QMainWindow {
	Q_OBJECT
public:
	GLViewer(const Parameters &params);
	~GLViewer();

	virtual void closeEvent(QCloseEvent * event);
protected slots:
	void help();
	void go();
	void clearFibers();
	void saveMDL();
	void saveOBJ();
	void loadMDL();
	void loadMDLComparison();
	void growFeature();
	void updateViews();
	void videoResolution();
	void itemClicked(QListWidgetItem* item);
	void modelChangeEvent(DataModel::EChangeLevel level);
private:
	GLWidget *m_widget;
	QGLFormat m_fmt;
	QListWidget *m_angleList;
	QWidget *m_toolWindow;
	QAction *m_updateViewsAct;
	QAction *m_showVolumeAct;
	DataModel *m_dataModel;
	QFont m_normalFont, m_boldFont;
	QPushButton *m_startButton;
	bool m_running;
	Timer m_timer;
	QTimer *m_frameTimer;
	size_t m_timerOffset;
};

#endif /* __GLVIEWER_H */
