#ifndef __GLWIDGET_H
#define __GLWIDGET_H

#include <hair/datamodel.h>
#include <QGLWidget>

class OverlayWidget;

class GLWidget : public QGLWidget {
	Q_OBJECT
public:
	GLWidget(const QGLFormat &fmt, QWidget *parent, DataModel *model);

	QSize minimumSizeHint() const;
	QSize sizeHint() const;
	QImage screenshot();
	void setRotationY(Float amount);

public slots:
	void modelChangeEvent(DataModel::EChangeLevel level);
protected:
	void initializeGL();
	void paintGL();
	void resizeGL(int width, int height);
	void mousePressEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);
	void mouseReleaseEvent(QMouseEvent *event);
	void wheelEvent(QWheelEvent * event);
	void keyPressEvent(QKeyEvent *event);
private:
	QPoint m_lastPos;
	DataModel *m_dataModel;
	float m_quat[4], m_dist;
	float m_offset[3];
	int m_mouseButton;
	OBB m_bounds, m_displayBounds;
	std::vector<KDTree::Observation *> m_result;
	Float m_rotationY;
	float m_colors[MAX_ACTIVESET_SIZE][3];
};

#endif /* __GLWIDGET_H */
