#if !defined(__IMAGEIO_H)
#define __IMAGEIO_H

#include <hair/common.h>

/* Load a 16-bit PNG file */
extern IplImage *cvLoadPNG16(const std::string &fname);

/* Save a 16-bit PNG file */
extern void cvSavePNG16(const std::string &fname, IplImage *image, CvRect roi = cvRect(-1,-1,-1,-1));

/* Load an 8-bit PNG file */
extern IplImage *cvLoadPNG8(const std::string &fname);

/* Save a 8-bit PNG file */
extern void cvSavePNG8(const std::string &fname, IplImage *image, CvRect roi = cvRect(-1,-1,-1,-1));

/* Get pixel values using bilinear interpolation */
uint8_t cvGetInterpolated(const IplImage *src, float y, float x);

/* Get pixel values using bilinear interpolation */
short cvGetInterpolated16(const IplImage *src, float y, float x);

#endif /* __IMAGEIO_H */
