#include <hair/common.h>
#include <iomanip>
#include <algorithm>
#include <stdarg.h>

std::string formatString(const char *pFmt, ...) {
	char tmp[2048];
	va_list iterator;

	va_start(iterator, pFmt);
	vsnprintf(tmp, 2048, pFmt, iterator);
	va_end(iterator);

	return std::string(tmp);
}

std::string timeToString(Float time) {
	std::ostringstream os;
	char suffix = 's';
#ifdef WIN32
	if (!_finite(time) || _isnan(time)) {
#else
	if (fpclassify(time) == FP_NAN || std::fpclassify(time) == FP_INFINITE) {
#endif
		return "inf";
	}
	os << std::setprecision(1) << std::fixed;
	if (time > 60) {
		time /= 60; suffix = 'm';
		if (time > 60) {
			time /= 60; suffix = 'h';
			if (time > 12) {
				time /= 12; suffix = 'd';
			}
		}
	}
	os << time << suffix;
	return os.str();
}
